var Twitter = function() {
	
    // XAuth specific parameters
    var OAUTH_REQUEST_TOKEN_URL = "https://api.twitter.com/oauth/request_token";
    var OAUTH_ACCESS_TOKEN_URL = "https://api.twitter.com/oauth/access_token";
    var OAUTH_AUTHORIZE_URL = "https://api.twitter.com/oauth/authorize";
	
	// Timelines
 	var HOME_TIMELINE_URL = "https://api.twitter.com/1/statuses/home_timeline.json";	
	var PUBLIC_TIMELINE_URL = "https://api.twitter.com/1/statuses/public_timeline.json";
	var MENTIONS_TIMELINE_URL = "https://api.twitter.com/1/statuses/mentions.json";
	var DIRECT_TIMELINE_URL = "https://api.twitter.com/1/direct_messages.json";
	var FAVOURITES_TIMELINE_URL = "https://api.twitter.com/1/favorites.json";
	var RETWEETSME_TIMELINE_URL = "https://api.twitter.com/1/statuses/retweets_of_me.json";
 	var TWEET_TIMELINE_URL = "https://api.twitter.com/1/statuses/show/@id.json";	
	
	// Lists
	var LISTS_URL = "https://api.twitter.com/1/@user/lists.json";
	
	// Users 
	var USER_URL = "http://api.twitter.com/1/users/show.json";
	
	// Actions
	var STATUS_UPDATE_URL = "https://api.twitter.com/1/statuses/update.json";
	var RETWEET_URL = "https://api.twitter.com/1/statuses/retweet/";
	var FAVOURITE_URL = "https://api.twitter.com/1/favorites/create/";
	var FOLLOW_URL = "https://api.twitter.com/1/friendships/create.json";
	var UNFOLLOW_URL = "https://api.twitter.com/1/friendships/destroy.json";
	var DIRECT_URL = "https://api.twitter.com/1/direct_messages/new.json";
	var SEARCH_URL = "http://search.twitter.com/search.json";
	
	// Searches
	var SEARCHES_URL = "https://api.twitter.com/1/saved_searches.json";
	
	var CONSUMER_KEY = "ZRutfKnGiKidRYjzfMVoRw";
	var CONSUMER_SECRET = "Er4znNVAR6UzaBXWiI1fCaEYHfh1BxlPdJwLvghdw";
		
	var sig = "hmac-sha1";
	var xauth = new XAuth();
	var hasToken = false;
	
	/** Login to Twitter */
	this.login = function(user,pass) {
		if(hasToken) {
			return;
		}
		if(typeof(user)!=undefined && user.length>0) {
			xauth.setUser(user,pass);
		}
		xauth.webRequest(false, OAUTH_ACCESS_TOKEN_URL, "", this.parseTokenSync);
	}
	
	this.resetToken = function() {
		hasToken = false;
	}
	
	this.handleTweets = function(data) {
		doTweets(data);
	}
	
	this.parseTokenSync = function(token) {
        var oauthToken = parseParameter(token, "oauth_token");
        var oauthTokenSecret = parseParameter(token, "oauth_token_secret");
		//console.log("oauth_token: " + oauthToken);
		//console.log("oauth_token_secret: " + oauthTokenSecret);
		if(typeof(oauthToken)=="undefined" || oauthToken.length==0) {
			return token + " " + xauth.getLastURL();
		}
		hasToken = true;
        xauth.setTokenAndSecret(oauthToken, oauthTokenSecret);	
		loadTimeline(HOME_TIMELINE_URL, false);
		return "ok";
	}
	
	/** Get tweets */
	this.getTweets = function(url, callback) {
		if(hasToken==false) {
			login();
		}
		xauth.webRequest(false, url, "", callback);
	}	
	
	/** Get lists */
	this.getLists = function(user, callback) {
		if(hasToken==false) {
			login();
		}
		var url = LISTS_URL.replace("@user", user);
		xauth.webRequest(false, url, "", callback);
	}	

	/** Get single tweet */
	this.getTweet = function(id, callback) {
		if(hasToken==false) {
			login();
		}
		var url = TWEET_TIMELINE_URL.replace("@id", id);
		xauth.webRequest(false, url, "", callback);
	}	

	/** Get saved searches */
	this.getSavedSearches = function(callback) {
		if(hasToken==false) {
			login();
		}
		xauth.webRequest(false, SEARCHES_URL, "", callback);
	}	
	
	/** Follow */
	this.follow = function(userid, callback) {
		$("#pleaseWaitText").append(".");
		var params = new Array();
		params.push(["user_id", userid]);
		xauth.webRequest(true, FOLLOW_URL, params, callback);
		$("#pleaseWaitText").append(".");
	}

	/** Unfollow */
	this.unfollow = function(userid, callback) {
		$("#pleaseWaitText").append(".");
		var params = new Array();
		params.push(["user_id", userid]);
		xauth.webRequest(true, UNFOLLOW_URL, params, callback);
		$("#pleaseWaitText").append(".");
	}

	
	/** Update status */
	this.updateStatus = function(status, replyid, lat, lon, callback) {
		var url = STATUS_UPDATE_URL + "?status=" + status;
		$("#pleaseWaitText").append(".");
		var params = new Array();
		params.push(["status", status]);
		if(typeof(replyid)!=undefined && replyid.length>0) {
			params.push(["in_reply_to_status_id", replyid]);
		}
		if(typeof(lat)!=undefined && lat!=null && lat.length>0) {
			params.push(["lat", lat.replace(",", ".")]);
			params.push(["long", lon.replace(",", ".")]);
			params.push(["display_coordinates", "true"]);
		}
		xauth.webRequest(true, STATUS_UPDATE_URL, params, callback);
		$("#pleaseWaitText").append(".");
	}
	
	this.searchTweets = function(url, callback) {
		$("#pleaseWaitText").append(".");
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
		}catch(e) {}
		
		var result = $.ajax({ 
			type: "GET", 
			url: url, 
			async: true,
			success: function(data) {
				if(callback!=null) {
					callback(data);
				}
			},
			error: function(request,status,errorThrown) {
				errorCallback();
			}
		}).responseText;
		$("#pleaseWaitText").append(".");
	}
	
	/** Update status */
	this.directTweet = function(status, userid, callback) {
		$("#pleaseWaitText").append("..");
		var params = new Array();
		params.push(["text", status]);
		params.push(["user_id", userid]);
		xauth.webRequest(true, DIRECT_URL, params, callback);
		$("#pleaseWaitText").append(".");
	}	
	
	/** Get user */
	this.getUser = function(userid, callback) {
		var params = new Array();
		params.push(["id", userid]);
		xauth.webRequest(false, USER_URL, params, callback);
	}
	
	/** Retweet */
	this.retweet = function(tweetid, callback) {
		xauth.webRequest(true, RETWEET_URL + tweetid + ".json", "", callback);
	}	

	/** Mark as favourite */
	this.favourite = function(tweetid, callback) {
		xauth.webRequest(true, FAVOURITE_URL + tweetid + ".json", "", callback);
	}	
	
	/** Parse parameter from given URL */
	parseParameter = function(url, parameter) {
        var parameterIndex = url.indexOf(parameter);
        if(parameterIndex<0) {
            // We didn't find parameter
            return "";
        }
        var equalIndex = url.indexOf("=", parameterIndex);
        if(equalIndex<0) {
            return "";
        }
        var value = "";
        var nextIndex = url.indexOf("&", equalIndex+1);
        if(nextIndex<0) {
            value = url.substring(equalIndex+1);
        } else {
            value = url.substring(equalIndex+1, nextIndex);
        }
        return value;
    }
	
	/* Old stuff from here on */
	
	this.requestToken = function() {
		try {		
		
			var accessor = {};
			accessor.consumerSecret = CONSUMER_SECRET;
			accessor.tokenSecret = "";
			var url = OAUTH_REQUEST_TOKEN_URL;
			var message = { action: url, method: "GET", parameters: [["oauth_version","1.0"],["oauth_consumer_key",CONSUMER_KEY]]};
			OAuth.setTimestampAndNonce(message);
			OAuth.SignatureMethod.sign(message, accessor);
			var parameterMap = OAuth.getParameterMap(message);
			var baseStr = OAuth.decodeForm(OAuth.SignatureMethod.getBaseString(message));           
			var theSig = "";
	 
			if (parameterMap.parameters) {
				for (var item in parameterMap.parameters) {
					for (var subitem in parameterMap.parameters[item]) {
						if (parameterMap.parameters[item][subitem] == "oauth_signature") {
							theSig = parameterMap.parameters[item][1];                    
							break;                      
						}
					}
				}
			}

			var paramList = baseStr[2][0].split("&");
			paramList.push("oauth_signature="+theSig);
			paramList.sort( function(a,b) {
				if (a[0] < b[0]) return -1;
				if (a[0] > b[0]) return 1;
				if (a[1] < b[1]) return  -1;
				if (a[1] > b[1]) return 1;
				return 0;
			});
	 
			var locString = "";
			for (var x in paramList) {
				locString += paramList[x] + "&";                
			}
	 
			var finalStr = baseStr[1][0] + "?" + locString.slice(0,locString.length - 1);
	
			alert("url: " + finalStr);
			xmlHttp = new XMLHttpRequest();
			xmlHttp.onreadystatechange = httpCallBack;
			xmlHttp.open('GET', finalStr, true);
			xmlHttp.send(null);		
		} 
		catch (e) {
			updateStatusMessage("Error: " + e);
		}			
	}
	
	function requestAccessToken(fail){

			updateStatusMessage("<blink>Preparing...</blink>");

			try {			

				//test server information : http://term.ie/oauth/example/

				var url = OAUTH_ACCESS_TOKEN_URL;

				var accessor = {};

				if(fail){
					accessor.consumerSecret = "wrongsecret";
					accessor.tokenSecret = "wrongaccesssecret";				
				}else{ 
					accessor.consumerSecret = "secret";
					accessor.tokenSecret = "requestsecret";
				}  

				var message = { action: url, method: "GET", parameters: [["oauth_version","1.0"],["oauth_consumer_key",CONSUMER_KEY],["oauth_token","requestkey"]]};

				OAuth.setTimestampAndNonce(message);
				OAuth.SignatureMethod.sign(message, accessor);

				var parameterMap = OAuth.getParameterMap(message);
				var baseStr = OAuth.decodeForm(OAuth.SignatureMethod.getBaseString(message));           
				var theSig = "";

				if (parameterMap.parameters) {
					for (var item in parameterMap.parameters) {
						for (var subitem in parameterMap.parameters[item]) {
							if (parameterMap.parameters[item][subitem] == "oauth_signature") {
								theSig = parameterMap.parameters[item][1];                    
								break;                      
							}
						}
					}
				}

				var paramList = baseStr[2][0].split("&");
				paramList.push("oauth_signature="+theSig);
				paramList.sort(function(a,b) {
					if (a[0] < b[0]) return -1;
					if (a[0] > b[0]) return 1;
					if (a[1] < b[1]) return -1;
					if (a[1] > b[1]) return 1;
					return 0;
				});

				var locString = "";
				for (var x in paramList) {
					locString += paramList[x] + "&";                
				}

				var finalStr = baseStr[1][0] + "?" + locString.slice(0,locString.length - 1);

				alert("url: " + finalStr);
				xmlHttp = new XMLHttpRequest();
				xmlHttp.onreadystatechange = AcessCallBack;
				xmlHttp.open('GET', finalStr, true);

				xmlHttp.send(null);

			} 
			catch (e) {
				updateStatusMessage("Error: " + e);
			}

		}

		function updateStatusMessage(aMessage) {
			$("#tweets").append( aMessage );
		};

		function AcessCallBack()
		{
			if (xmlHttp.readyState == 1){
				updateStatusMessage("<blink>Access Opening HTTP...</blink>");
			}else if (xmlHttp.readyState == 2){
				updateStatusMessage("<blink>Sending query...</blink>");
			}else if (xmlHttp.readyState == 3){ 
				updateStatusMessage("<blink>Receiving...</blink>");
			}else if (xmlHttp.readyState == 4){
				updateStatusMessage("Done");
				//for(x in xmlHttp){
					//if(typeof xmlHttp[x] != 'function')
					//alert(x + " = " + xmlHttp[x]);
				//}
				updateStatusMessage(xmlHttp.responseText);
				tryparse(xmlHttp.responseText,true);	
			}
		}
		
		function httpCallBack()
		{
			if (xmlHttp.readyState == 1){
				updateStatusMessage("<blink>Opening HTTP...</blink>");
			}else if (xmlHttp.readyState == 2){
				updateStatusMessage("<blink>Sending query...</blink>");
			}else if (xmlHttp.readyState == 3){ 
				updateStatusMessage("<blink>Receiving...</blink>");
			}else if (xmlHttp.readyState == 4){
				updateStatusMessage("Done");
				//for(x in xmlHttp){
					//if(typeof xmlHttp[x] != 'function')
					//alert(x + " = " + xmlHttp[x]);
				//}
				updateStatusMessage(xmlHttp.responseText);
				tryparse(xmlHttp.responseText,false);
			}
		}
		
		function tryparse(reply,access){

			var nvPairs = reply.split("&");

			for (i = 0; i < nvPairs.length; i++) {

				var nvPair = nvPairs[i].split("=");
				var name = nvPair[0];

				if (access) {
					if(name == "oauth_token_secret"){
						updateStatusMessage( "Token secret: " + nvPair[1] );
					}else if(name == "oauth_token"){
						updateStatusMessage( "Token: " + nvPair[1] );
					}
				}else{
					if(name == "oauth_token_secret"){
						updateStatusMessage( "Token secret: " + nvPair[1] );
					}else if(name == "oauth_token"){
						updateStatusMessage( "Token: " + nvPair[1] );
					}

				}
			}
		}				
	
}

